{Tera Term
 Copyright(C) 1994-1996 T. Teranishi
 All rights reserved.}

{TERATERM.EXE, TEK window}
unit TEK;

interface
{$I teraterm.inc}

{$IFDEF Delphi}
uses Messages, WinTypes, WinProcs, OWindows, Strings,
     TeraPrn, Keyboard, Clipboard, TTWinMan,
     TTDialog, TTTypes, TTCommon, TEKTypes, Ctl3d;
{$ELSE}
uses WinTypes, WinProcs, WObjects, Strings,
     Win31, TeraPrn, Keyboard, Clipboard, TTWinMan,
     TTDialog, TTTypes, TTCommon, TEKTypes, Ctl3d;
{$ENDIF}

type
  TTEKInit = procedure(tk: PTEKVar; ts: PTTSet);
  TTEKResizeWindow = procedure(tk: PTEKVar; ts: PTTSet; W, H: Integer);
  TChangeCaret = procedure(tk: PTEKVar; ts: PTTSet);
  TTEKParse = function(tk: PTEKVar; ts: PTTSet; cv: PComVar): integer;
  TReportGIN = procedure(tk: PTEKVar; ts: PTTSet; cv: PComVar; KeyCode: byte);
  TTEKPaint = procedure(tk: PTEKVar; ts: PTTSet; PaintDC: HDC; PaintInfo: PPaintStruct);
  TTEKWMLButtonDown = procedure(tk: PTEKVar; ts: PTTSet; cv: PComVar; Popup: BOOL; pos: TPoint);
  TTEKWMLButtonUp = procedure(tk: PTEKVar; ts: PTTSet);
  TTEKWMMouseMove = procedure(tk: PTEKVar; ts: PTTSet; p: TPoint);
  TTEKWMSize = procedure(tk: PTEKVar; ts: PTTSet; W, H, cx, cy: Integer);
  TTEKCMCopy = procedure(tk: PTEKVar; ts: PTTSet);
  TTEKCMCopyScreen = procedure(tk: PTEKVar; ts: PTTSet);
  TTEKInitMenu = procedure(tk: PTEKVar; cv: PComVar; SubMenu: HMenu);
  TTEKPrint = procedure(tk: PTEKVar; ts: PTTSet; PrintDC: HDC; SelFlag: longint);
  TTEKClearScreen = procedure(tk: PTEKVar);
  TTEKSetupFont = procedure(tk: PTEKVar; ts: PTTSet);
  TTEKSetupWinDlg = procedure(tk: PTEKVar; ts: PTTSet);
  TTEKRestoreSetup = procedure(tk: PTEKVar; ts: PTTSet);
  TTEKEnd = procedure(tk: PTEKVar);
  TTEKChangeMenu = procedure(tk: PTEKVar; ts: PTTSet);

type
  PTEKWindow = ^TEKWindow;

  TEKWindow = object(TWindow)

    tk: TTEKVar;

    constructor Init;
    procedure DefWndProc(var Msg: TMessage); virtual;
    procedure SetupWindow; virtual;
    function GetClassName: PChar; virtual;
    procedure GetWindowClass(var AWndClass: TWndClass); virtual;

    function Parse: integer;

    procedure WMDestroy(var Msg: TMessage);
      virtual wm_First + wm_Destroy;
    procedure WMGetMinMaxInfo(var Msg: TMessage);
      virtual wm_First + wm_GetMinMaxInfo;
    procedure WMSysKeyDown(var Msg: TMessage);
      virtual wm_First + wm_SysKeyDown;
    procedure WMSysKeyUp(var Msg: TMessage);
      virtual wm_First + wm_SysKeyUp;
    procedure WMKeyDown(var Msg: TMessage);
      virtual wm_First + wm_KeyDown;
    procedure WMKeyUp(var Msg: TMessage);
      virtual wm_First + wm_KeyUp;
    procedure WMChar(var Msg: TMessage);
      virtual wm_First + wm_Char;
    procedure WMInitMenuPopup(var Msg: TMessage);
      virtual wm_First + wm_InitMenuPopup;
    procedure WMActivate(var Msg: TMessage);
      virtual wm_First + wm_Activate;

    procedure WMLButtonDown(Var Msg: TMessage);
      virtual wm_First + wm_LButtonDown;
    procedure WMLButtonUp(Var Msg: TMessage);
      virtual wm_First + wm_LButtonUp;
    procedure WMMButtonUp(Var Msg: TMessage);
      virtual wm_First + wm_MButtonUp;
    procedure WMRButtonUp(Var Msg: TMessage);
      virtual wm_First + wm_RButtonUp;
    procedure WMMouseMove(Var Msg: TMessage);
      virtual wm_First + wm_MouseMove;
    procedure Paint(PaintDC: HDC; var PaintInfo:TPaintStruct); virtual;
    procedure WMSize(Var Msg: TMessage);
      virtual wm_First + wm_Size;
    procedure WMMove(var Msg: TMessage);
    virtual wm_First + wm_Move;
    procedure WMSysCommand(var Msg: TMessage);
      virtual wm_First + wm_SysCommand;

    procedure WMChangeMenu(var Msg: TMessage);
      virtual wm_User + MsgChangeMenu;
    procedure WMDlgHelp(var Msg: TMessage);
      virtual wm_User + MsgDlgHelp2;

    procedure CMFilePrint(var Msg: TMessage);
      virtual cm_First + cm_FilePrint;
    procedure CMFileExit(var Msg: TMessage);
      virtual cm_First + cm_FileExit;
    procedure CMEditCopy(var Msg: TMessage);
      virtual cm_First + cm_EditCopy;
    procedure CMEditCopyScreen(var Msg: TMessage);
      virtual cm_First + cm_EditCopyScreen;
    procedure CMEditPaste(var Msg: TMessage);
      virtual cm_First + cm_EditPaste;
    procedure CMEditPasteCR(var Msg: TMessage);
      virtual cm_First + cm_EditPasteCR;
    procedure CMEditClearScreen(var Msg: TMessage);
      virtual cm_First + cm_EditClearScreen;
    procedure CMSetupWindow(var Msg: TMessage);
      virtual cm_First + cm_SetupWindow;
    procedure CMSetupFont(var Msg: TMessage);
      virtual cm_First + cm_SetupFont;
    procedure RestoreSetup;
    procedure CMVTWin(var Msg: TMessage);
      virtual cm_First + cm_VTWin;
    procedure CMHelpIndex(var Msg: TMessage);
      virtual cm_First + cm_HelpIndex;
    procedure CMHelpUsing(var Msg: TMessage);
      virtual cm_First + cm_HelpUsing;
    procedure CMAbout(var Msg: TMessage);
      virtual cm_First + cm_About;

  end;

var
  TEKPtr: PTEKWindow;

  HTTTEK: THandle;
  TEKInit: TTEKInit;
  TEKResizeWindow: TTEKResizeWindow;
  ChangeCaret: TChangeCaret;
  TEKParse: TTEKParse;
  ReportGIN: TReportGIN;
  TEKPaint: TTEKPaint;
  TEKWMLButtonDown: TTEKWMLButtonDown;
  TEKWMLButtonUp: TTEKWMLButtonUp;
  TEKWMMouseMove: TTEKWMMouseMove;
  TEKWMSize: TTEKWMSize;
  TEKCMCopy: TTEKCMCopy;
  TEKCMCopyScreen :TTEKCMCopyScreen;
  TEKInitMenu: TTEKInitMenu;
  TEKPrint: TTEKPrint;
  TEKClearScreen: TTEKClearScreen;
  TEKSetupFont: TTEKSetupFont;
  TEKSetupWinDlg: TTEKSetupWinDlg;
  TEKRestoreSetup: TTEKRestoreSetup;
  TEKEnd: TTEKEnd;
  TEKChangeMenu: TTEKChangeMenu;

function LoadTTTEK: bool;
procedure FreeTTTEK;
procedure TEKActivate;


implementation

constructor TEKWindow.Init;
begin
  TWindow.Init(nil, nil);

  if not LoadTTTEK then
  begin
    CloseWindow;
  end;

  TEKInit(@tk,@ts); {Attr.Menu}
  Attr.Menu := tk.MainMenu;

  if ts.HideTitle>0 then
    Attr.Style := ws_visible or ws_popup or ws_thickframe or ws_border
  else
    Attr.Style := ws_Visible or ws_Caption or ws_SysMenu or
                  ws_MinimizeBox or ws_Border or ws_ThickFrame;

  Attr.W := tk.ScreenWidth;
  Attr.H := tk.ScreenHeight;
  Attr.X := ts.TEKPos.X;
  Attr.Y := ts.TEKPos.Y;
end;

procedure TEKWindow.SetupWindow;
begin
  HTEKWin := HWindow;
  tk.HWin := HWindow;
  ChangeTitle;

  TEKResizeWindow(@tk,@ts,Attr.W,Attr.H);

  if ts.PopupMenu>0 then
    PostMessage(HWindow,wm_user+MsgChangeMenu,0,0);

  TWindow.SetupWindow;
end;

function TEKWindow.GetClassName: PChar;
begin
  GetClassName := 'TEKWin';
end;

procedure TEKWindow.GetWindowClass(var AWndClass: TWndClass);
begin
  TWindow.GetWindowClass(AWndClass);
  AWndClass.hbrBackground := 0; {BackGround}
  AWndClass.HIcon := LoadIcon(HInstance, PChar(IdTEKIcon));
end;

procedure TEKWindow.DefWndProc(var Msg: TMessage);
begin
  if Msg.Message=MsgDlgHelp then
    WMDlgHelp(Msg)
  else if (ts.HideTitle>0) and
          (Msg.Message=wm_first+wm_nchittest) then
  begin
    TWindow.DefWndProc(Msg);
    if (Msg.Result=HTCLIENT) and AltKey then
      Msg.Result := HTCAPTION;
  end         
  else
    TWindow.DefWndProc(Msg);
end;

function TEKWindow.Parse: integer;
begin
  Parse := TEKParse(@tk,@ts,@cv);
end;

{$I TEKwm.pas}
{$I TEKcm.pas}

const
  IdTEKInit          = 1;
  IdTEKResizeWindow  = 2;
  IdChangeCaret      = 3;
  IdTEKParse         = 4;
  IdReportGIN        = 5;
  IdTEKPaint         = 6;
  IdTEKWMLButtonDown = 7;
  IdTEKWMLButtonUp   = 8;
  IdTEKWMMouseMove   = 9;
  IdTEKWMSize        = 10;
  IdTEKCMCopy        = 11;
  IdTEKCMCopyScreen  = 12;
  IdTEKInitMenu      = 13;
  IdTEKPrint         = 14;
  IdTEKClearScreen   = 15;
  IdTEKSetupFont     = 16;
  IdTEKSetupWinDlg   = 17;
  IdTEKRestoreSetup  = 18;
  IdTEKEnd           = 19;
  IdTEKChangeMenu    = 20;

function LoadTTTEK: bool;
var
  Err: boolean;
begin
  if HTTTEK >= 32 then
  begin
    LoadTTTEK := true;
    exit;
  end
  else
    LoadTTTEK := false;

  HTTTEK := LoadLibrary('TTTEK.DLL');
  if HTTTEK < 32 then exit;

  Err := false;
  @TEKInit := GetProcAddress(HTTTEK, PChar(IdTEKInit));
  if @TEKInit=nil then Err := true;
  
  @TEKResizeWindow := GetProcAddress(HTTTEK, PChar(IdTEKResizeWindow));
  if @TEKResizeWindow=nil then Err := true;

  @ChangeCaret := GetProcAddress(HTTTEK, PChar(IdChangeCaret));
  if @ChangeCaret=nil then Err := true;

  @TEKParse := GetProcAddress(HTTTEK, PChar(IdTEKParse));
  if @TEKParse=nil then Err := true;

  @ReportGIN := GetProcAddress(HTTTEK, PChar(IdReportGIN));
  if @ReportGIN=nil then Err := true;

  @TEKPaint := GetProcAddress(HTTTEK, PChar(IdTEKPaint));
  if @TEKPaint=nil then Err := true;

  @TEKWMLButtonDown := GetProcAddress(HTTTEK, PChar(IdTEKWMLButtonDown));
  if @TEKWMLButtonDown=nil then Err := true;

  @TEKWMLButtonUp := GetProcAddress(HTTTEK, PChar(IdTEKWMLButtonUp));
  if @TEKWMLButtonUp=nil then Err := true;

  @TEKWMMouseMove := GetProcAddress(HTTTEK, PChar(IdTEKWMMouseMove));
  if @TEKWMMouseMove=nil then Err := true;

  @TEKWMSize := GetProcAddress(HTTTEK, PChar(IdTEKWMSize));
  if @TEKWMSize=nil then Err := true;

  @TEKCMCopy := GetProcAddress(HTTTEK, PChar(IdTEKCMCopy));
  if @TEKCMCopy=nil then Err := true;

  @TEKCMCopyScreen := GetProcAddress(HTTTEK, PChar(IdTEKCMCopyScreen));
  if @TEKCMCopyScreen=nil then Err := true;

  @TEKInitMenu := GetProcAddress(HTTTEK, PChar(IdTEKInitMenu));
  if @TEKInitMenu=nil then Err := true;

  @TEKPrint := GetProcAddress(HTTTEK, PChar(IdTEKPrint));
  if @TEKPrint=nil then Err := true;

  @TEKClearScreen := GetProcAddress(HTTTEK, PChar(IdTEKClearScreen));
  if @TEKClearScreen=nil then Err := true;

  @TEKSetupFont := GetProcAddress(HTTTEK, PChar(IdTEKSetupFont));
  if @TEKSetupFont=nil then Err := true;

  @TEKSetupWinDlg := GetProcAddress(HTTTEK, PChar(IdTEKSetupWinDlg));
  if @TEKSetupWinDlg=nil then Err := true;

  @TEKRestoreSetup := GetProcAddress(HTTTEK, PChar(IdTEKRestoreSetup));
  if @TEKRestoreSetup=nil then Err := true;

  @TEKEnd := GetProcAddress(HTTTEK, PChar(IdTEKEnd));
  if @TEKEnd=nil then Err := true;

  @TEKChangeMenu := GetProcAddress(HTTTEK, PChar(IdTEKChangeMenu));
  if @TEKChangeMenu=nil then Err := true;

  if Err then
  begin
    FreeLibrary(HTTTEK);
    HTTTEK := 0;
  end
  else LoadTTTEK := true;

end;

procedure FreeTTTEK;
begin
  if HTTTEK >= 32 then
  begin
    FreeLibrary(HTTTEK);
    HTTTEK := 0;
  end;
end;

procedure TEKActivate;
begin
  ActiveWin := IdTEK;
  if HTEKWin=0 then
    TEKPtr := PTEKWindow(Application^.MakeWindow(New(PTEKWindow,Init)))
  else begin
    TEKPtr^.Show(sw_ShowNormal);
    SetFocus(HTEKWin);
  end;
end;

begin
  HTTTEK := 0;
  TEKPtr := nil;
end.
