{Tera Term
 Copyright(C) 1994-1996 T. Teranishi
 All rights reserved.}

{TTTEK.DLL, TEK escape sequences}
procedure SelectCode(tk: PTEKVar; ts: PTTSet; b: byte);
begin
with tk^ do begin
  case b of
    NUL..US: exit;
    ord(' '): begin
        if SelectCodeFlag = ord('#') then SelectCodeFlag := b;
        exit;
      end;
    ord('!'): begin
        if SelectCodeFlag = ord('%') then SelectCodeFlag := b;
        exit;
      end;
    ord('1')..Ord('2'): if (SelectCodeFlag=ord(' ')) or
                           (SelectCodeFlag=ord('!')) then ChangeEmu := IdVT; {enter VT mode}
    ord('3'): if SelectCodeFlag=ord('!') then ChangeEmu := IdVT; {enter VT mode}
    ord('5'): if SelectCodeFlag=ord(' ') then ChangeEmu := IdVT; {enter VT mode}
  end;
  if ($20<=b) and (b<$7f) then ParseMode := ModeFirst;
  SelectCodeFlag := 0;
  if ts^.AutoWinSwitch>0 then ChangeEmu := 0;
end;
end;

function ColorIndex(Fore, Back: TColorRef; w: word): TColorRef;
begin
  case w of
    1: ColorIndex := Fore;
    2: ColorIndex := RGB(255,  0,  0); {Red}
    3: ColorIndex := RGB(  0,255,  0); {Green}
    4: ColorIndex := RGB(  0,  0,255); {Blue}
    5: ColorIndex := RGB(  0,255,255); {Cyan}
    6: ColorIndex := RGB(255,  0,255); {Magenta}
    7: ColorIndex := RGB(255,255,  0); {Yellow}
    8: ColorIndex := RGB(255,128,  0); {Orange}
    9: ColorIndex := RGB(128,255,  0); {Green-Yellow}
   10: ColorIndex := RGB(  0,255,128); {Green-Cyan}
   11: ColorIndex := RGB(  0,128,255); {Blue-Cyan}
   12: ColorIndex := RGB(128,  0,255); {Blue-Magenta}
   13: ColorIndex := RGB(255,  0,128); {Red-Magenta}
   14: ColorIndex := RGB( 85, 85, 85); {Dark gray}
   15: ColorIndex := RGB(170,170,170); {Light gray}
  else
    ColorIndex := Back;
  end;
end;

procedure SetLineIndex(tk: PTEKVar; ts: PTTSet; w: word);
var
  TempDC: HWnd;
begin
with tk^ do begin
  PenColor := ColorIndex(ts^.TEKColor[0],ts^.TEKColor[1],w);
  TempDC := GetDC(HWin);
  PenColor := GetNearestColor(TempDC,PenColor);
  ReleaseDC(HWin,TempDC);
  if ts^.TEKColorEmu>0 then
    MemPenColor := PenColor
  else
    if PenColor=ts^.TEKColor[1] then
      MemPenColor := MemBackColor
    else
      MemPenColor := MemForeColor;

  DeleteObject(Pen);
  Pen := CreatePen(ps,1,PenColor);
  
  SelectObject(MemDC, OldMemPen);
  DeleteObject(MemPen);
  MemPen := CreatePen(ps,1,MemPenColor);
  OldMemPen := SelectObject(MemDC,MemPen);
end;
end;

procedure SetTextIndex(tk: PTEKVar; ts: PTTSet; w: word);
var
  TempDC: HWnd;
begin
with tk^ do begin
  TextColor := ColorIndex(ts^.TEKColor[0],ts^.TEKColor[1],w);
  TempDC := GetDC(HWin);
  TextColor := GetNearestColor(TempDC,ts^.TEKColor[0]);
  ReleaseDC(HWin,TempDC);
  if ts^.TEKColorEmu>0 then
    MemTextColor := ts^.TEKColor[0]
  else
    if TextColor<>ts^.TEKColor[1] then
      MemTextColor := MemBackColor
    else
      MemTextColor := MemForeColor;

  SetTextColor(MemDC, MemTextColor)
end;
end;

procedure SetLineStyle(tk: PTEKVar; b: byte);
begin
with tk^ do begin
  case b of
    0: ps := ps_solid;
    1: ps := ps_dot;
    2: ps := ps_dashdot;
    3: ps := ps_dash;
    4: ps := ps_dash;
    5: ps := ps_dashdotdot;
    6: ps := ps_dashdot;
    7: ps := ps_dash;
    8: ps := ps_dashdotdot;
  else
    ps := ps_solid;
  end;
  if Pen<>0 then DeleteObject(Pen);
  Pen := CreatePen(ps,1,PenColor);

  SelectObject(MemDC, OldMemPen);
  if MemPen<>0 then DeleteObject(MemPen);
  MemPen := CreatePen(ps,1,MemPenColor);
  OldMemPen := SelectObject(MemDC,MemPen);
end;
end;

procedure TwoOpCode(tk: PTEKVar; ts: PTTSet; cv: PComVar; b: byte);
begin
with tk^ do begin

  if OpCount=2 then
  begin
    dec(OpCount);
    Op2OC := b*256;
    exit;
  end
  else if OpCount=1 then
  begin
    case b of
      $00..$1A: exit;
      $1B..$1F: begin
          CommInsert1Byte(cv,b);
          ParseMode := ModeFirst;
          exit;
        end;
    else
      begin 
        dec(OpCount);
        Op2OC := Op2OC + b;
        case Op2OC of
          IdMove: PrmCountMax := 0;
          IdDraw: PrmCountMax := 0;
          IdSetLineIndex: PrmCountMax := 1;
          IdSetTextIndex: PrmCountMax := 1;
          IdSetLineStyle: PrmCountMax := 1;
        else
          PrmCountMax := 0;
        end;
        Prm2OC := 0;
        PrmCount := 0;
        if PrmCountMax>0 then exit;
      end;
    end;
  end;

  if PrmCount<PrmCountMax then
    case b of
      $00..$1A: exit;
      $1B..$1F: begin
          CommInsert1Byte(cv,b);
          PrmCount := PrmCountMax;
          ParseMode := ModeFirst;
        end;
      $20..$2F: begin  {LoI (minus)}
          Prm2OC := - (Prm2OC*16 + b - $20);
          inc(PrmCount);
        end;
      $30..$3F: begin  {LoI (plus)}
          Prm2OC := Prm2OC*16 + b - $30;
          inc(PrmCount);
        end;
      $40..$7F: Prm2OC := Prm2OC*64 + b - $40;
    end;

  if PrmCount<PrmCountMax then exit;

  case Op2OC of
    IdMove: begin
        LoXReceive := false;
        LoCount := 0;
        Drawing := true;
        MoveFlag := true;
      end;
    IdDraw: begin
        LoXReceive := false;
        LoCount := 0;
        Drawing := true;
        MoveFlag := false;
      end;
    IdSetLineIndex: SetLineIndex(tk,ts,Prm2OC);
    IdSetTextIndex: SetTextIndex(tk,ts,Prm2OC);
    IdSetLineStyle: SetLineStyle(tk,byte(Prm2OC));
  end;

  ParseMode := ModeFirst;

end;
end;


procedure Escape(tk: PTEKVar; ts: PTTSet; cv: PComVar; b: byte);
  
  procedure Page(tk: PTEKVar); {Clear Screen and enter ALPHAMODE}
  begin
  with tk^ do begin
    SetLineStyle(tk,0);
    GetClientRect(HWin,R);
    FillRect(MemDC,R,MemBackGround);
    InvalidateRect(HWin,@R,false);
    EnterAlphaMode(tk);
    CaretX := 0;
    CaretOffset := 0;
    CaretY := 0;
  end;
  end;

begin
with tk^ do begin
  case b of
    $00: exit;
    $0d: exit;
    $0a: exit;
    $0C: Page(tk);
    $1A: begin
           GIN := true;
           {Capture mouse}
           SetCapture(HWin);
           EnterAlphaMode(tk);
         end;
    $1B: exit;
    $1C..$1F: CommInsert1Byte(cv,b);
    Ord('#'): begin
                ParseMode := ModeSelectCode;
                SelectCodeFlag := b;
                exit;
              end;
    Ord('%'): begin
                ParseMode := ModeSelectCode;
                SelectCodeFlag := b;
                exit;
              end;
    Ord('2'): if ts^.AutoWinSwitch>0 then ChangeEmu := IdVT; {Enter VT Mode}
    Ord('8')..Ord(';'): begin
                          if TextSize<>b-$38 then
                          begin
                            TextSize := b-$38;
                            ChangeTextSize(tk,ts);
                          end;
                        end;
    Ord('I')..Ord('Z'): begin
                          ParseMode := Mode2OC;
                          OpCount := 2;
                          TwoOpCode(tk,ts,cv,b);
                          exit;
                        end;
    Ord('['): if ts^.AutoWinSwitch>0 then
              begin
                CommInsert1Byte(cv,$5B);
                CommInsert1Byte(cv,$1B);
                ChangeEmu := IdVT;
              end;
    $60..$6f: SetLineStyle(tk,(b-$60) and 7);
    $7f: exit;
  end;
  ParseMode := ModeFirst;
end;
end;
