{Tera Term
 Copyright(C) 1994-1996 T. Teranishi
 All rights reserved.}

{TTMACRO.EXE, DDE routines}
unit TTMDDE;

interface
{$I teraterm.inc}

{$IFDEF Delphi}
uses WinTypes, WinProcs, OWindows, Strings, DDEML, TTMParse, TTMDlg;
{$ELSE}
uses WinTypes, WinProcs, WObjects, Strings, DDEML, TTMParse, TTMDlg;
{$ENDIF}

const
  RingBufSize = 2048;

const
  CmdSetHWnd      = ' ';
  CmdSetFile      = '!';
  CmdSetBinary    = '"';
  CmdSetAppend    = '#';
  CmdSetXmodemOpt = '$';

  CmdBPlusRecv    = '%';
  CmdBPlusSend    = '&';
  CmdChangeDir    = #$27; {'}
  CmdCloseWin     = '(';
  CmdKmtRecv      = ')';
  CmdKmtSend      = '*';
  CmdLogClose     = '+';
  CmdLogOpen      = ',';
  CmdLogPause     = '-';
  CmdLogStart     = '.';
  CmdLogWrite     = '/';
  CmdQVRecv       = '0';
  CmdQVSend       = '1';
  CmdSendFile     = '2';
  CmdShowMin      = '3';
  CmdShowRestore  = '4';
  CmdXmodemSend   = '5';
  CmdXmodemRecv   = '6';
  CmdZmodemSend   = '7';
  CmdZmodemRecv   = '8';

var
  ConvH: HConv;
  OutLen: integer;
  HWin{, HWndSrv}: HWnd;
  ComReady: word;
  {for "WaitRecv" command}
  Wait2Str, Wait2SubStr: TStrVal;
  Wait2Count, Wait2Len,
  Wait2SubLen, Wait2SubPos: integer;
  Wait2Found: BOOL;

function InitDDE: boolean;
procedure EndDDE;
procedure DDEOut1Byte(B: byte);
procedure DDEOut(B: PChar);
procedure DDESend;
function Read1Byte(var b: byte): boolean;
procedure ClearWait;
procedure SetWait(Index: integer; Str: PChar);
procedure SetWait2(Str: PChar; Len, Pos: integer);
function Wait: integer;
function Wait2: BOOL;
procedure SetFile(FN: PChar);
procedure SetBinary(BinFlag: word);
procedure SetAppend(AppendFlag: word);
procedure SetXOption(XOption: word);
function SendCmnd(OpId: char; Wait: boolean): word;
procedure Byte2HexStr(b: BYTE; HexStr: PChar);

implementation

const
  ServiceName = 'TERATERM';
  ItemName = 'DATA';

var
  i: integer;
  Inst: Longint;
  DdeCallBackPtr: ^TCallback;
  Service: HSz;
  Topic: HSz;
  Item: HSz;
  FFFlag: boolean;

  OutBuf: array[0..82] of char;

  RingBuf: array[0..RingBufSize-1] of char;
  RBufStart, RBufPtr, RBufCount: integer;

  {for 'Wait' command}
  PWaitStr: array[1..10] of PChar;
  WaitStrLen: array[1..10] of integer;
  WaitCount: array[1..10] of integer;

{ring buffer}
procedure Put1Byte(b: byte);
begin
  RingBuf[RBufPtr] := char(b);
  inc(RBufPtr);
  if RBufPtr>=RingBufSize then RBufPtr := RBufPtr-RingBufSize;
  if RBufCount>=RingBufSize then
  begin
    RBufCount := RingBufSize;
    RBufStart := RBufPtr;
  end
  else
    inc(RBufCount);
end;

function Read1Byte(var b: byte): boolean;
begin
  if RBufCount>0 then
    Read1Byte := true
  else begin
    Read1Byte := false;
    exit;
  end;
  b := byte(RingBuf[RBufStart]);
  inc(RBufStart);
  if RBufStart>=RingBufSize then RBufStart := RBufStart-RingBufSize;
  dec(RBufCount);
  if FFFlag then
  begin
    if b=$FE then b := 0;
    FFFlag := false;
  end
  else begin
    FFFlag := b=$FF;
    Read1Byte := not FFFlag;
  end;
end;

function AcceptData(ItemHSz: HSz; Data: HDDEData): HDDEData;
var
  DH: HDDEData;
  DPtr: pointer;
  DSize: longint;
  b: byte;
begin
  AcceptData := 0;
  if DdeCmpStringHandles(ItemHSz, Item) <> 0 then exit;
  AcceptData := DDE_FACK;

  DH := Data;
  if DH=0 then
    DH := DdeClientTransaction(nil,0,ConvH,Item,CF_OEMTEXT,XTYP_Request,1000,nil);

  if DH=0 then exit;
  DPtr := DdeAccessData(DH,@DSize);
  if DPtr=nil then exit;
  i := 0;
  b := byte( PChar(DPtr)[i] );
  while (i<DSize-1) and (b>0) do
  begin
    Put1Byte(b);
    if i<DSize-1 then inc(i);
    b := byte( PChar(DPtr)[i] );
  end;
  DdeUnaccessData(DH);

  DdeFreeDataHandle(DH);
end;

{ CallBack Procedure for DDEML }
function DDECallbackProc(CallType, Fmt: Word; Conv: HConv; hsz1, hsz2: HSZ;
  Data: HDDEData; Data1, Data2: Longint): HDDEData; export;
begin
  DDECallbackProc := 0;

  case CallType of
    xtyp_Register: ;
    xtyp_Unregister: ;
    xtyp_xAct_Complete: ;
    xtyp_AdvData:
        DDECallbackProc := AcceptData(HSz2,Data);
    xtyp_Disconnect:
      begin
        ConvH := 0;
        PostQuitMessage(0);
      end;
  end;
end;

procedure Byte2HexStr(b: BYTE; HexStr: PChar);
begin
  if b < $a0 then
    HexStr[0] := char($30 + (b shr 4))
  else
    HexStr[0] := char($37 + (b shr 4));
  if (b and $0f) < $0a then
    HexStr[1] := char($30 + (b and $0f))
  else
    HexStr[1] := char($37 + (b and $0f));
  HexStr[2] := #0;
end;

function InitDDE: boolean;
var
  w: WORD;
  Cmd: array[0..5] of char;
begin
  InitDDE := false;
  DdeCallBackPtr:= MakeProcInstance(@DdeCallBackProc, HInstance);
  if DdeCallBackPtr=nil then exit;

  if DdeInitialize(Inst, TCallback(DdeCallBackPtr), AppCmd_ClientOnly,0)
     <> dmlErr_No_Error then exit;

  Service:= DdeCreateStringHandle(Inst, ServiceName, cp_WinAnsi);
  Topic  := DdeCreateStringHandle(Inst, TopicName, cp_WinAnsi);
  Item   := DdeCreateStringHandle(Inst, ItemName, cp_WinAnsi);
  if (Service=0) or (Topic=0) or (Item=0) then exit;

  ConvH := DdeConnect(Inst, Service, Topic, nil);
  if ConvH = 0 then exit;

  w := Application^.MainWindow^.HWindow;
  Cmd[0] := CmdSetHWnd;
  Byte2HexStr(Hi(w),@Cmd[1]);
  Byte2HexStr(Lo(w),@Cmd[3]);
  DdeClientTransaction(@Cmd[0],StrLen(Cmd)+1,ConvH,0,
    CF_OEMTEXT,XTYP_EXECUTE,1000,nil);

  DdeClientTransaction(nil,0,ConvH,Item,
    CF_OEMTEXT,XTYP_ADVSTART,1000,nil);

  InitDDE := true;
end;

procedure EndDDE;
begin
  if ConvH<>0 then DdeDisconnect(ConvH);

  if Service <> 0 then
    DdeFreeStringHandle(Inst, Service);
  if Topic <> 0 then
    DdeFreeStringHandle(Inst, Topic);
  if Item <> 0 then
    DdeFreeStringHandle(Inst, Item);

  if Inst <> 0 then
    DdeUninitialize(Inst);   { Ignore the return value }

  if DdeCallBackPtr <> nil then
    FreeProcInstance(DdeCallBackPtr);
end;

procedure DDEOut1Byte(B: byte);
begin
  if OutLen < SizeOf(OutBuf)-1 then
  begin
    OutBuf[OutLen] := char(B);
    inc(OutLen);
    OutBuf[OutLen] := #0;
  end;
  if ((B=0) or (B=$FF)) and
     (OutLen < SizeOf(OutBuf)-1) then
  begin
    OutBuf[OutLen] := char($FE + B and 1);
    inc(OutLen);
    OutBuf[OutLen] := #0;
  end;
end;

procedure DDEOut(B: PChar);
begin
  if OutLen=0 then OutBuf[0] := #0;
  StrLCat(OutBuf,B,SizeOf(OutBuf)-1);
  OutLen := StrLen(OutBuf);
end;

procedure DDESend;
var
  Ok: longint;
begin
  if (ConvH=0) or (OutLen=0) then exit;
  Ok := DdeClientTransaction(@OutBuf[0],OutLen+1,ConvH,Item,CF_OEMTEXT,XTYP_POKE,1000,nil);
  if Ok<>0 then
    OutLen := 0;
end;

procedure ClearWait;
begin
  for i := 1 to 10 do
  begin
    if PWaitStr[i]<>nil then
      StrDispose(PWaitStr[i]);
    PWaitStr[i] := nil;
    WaitStrLen[i] := 0;
    WaitCount[i] := 0;
  end;
end;

procedure SetWait(Index: integer; Str: PChar);
begin
  if PWaitStr[Index]<>nil then
    StrDispose(PWaitStr[Index]);
  PWaitStr[Index] := StrNew(Str);
  WaitStrLen[Index] := StrLen(Str);
  WaitCount[Index] := 0;
end;

procedure SetWait2(Str: PChar; Len, Pos: integer);
begin
  strcopy(Wait2SubStr,Str);
  Wait2SubLen := strlen(Wait2SubStr);

  if Len<1 then
    Wait2Len := 0
  else if Len>MaxStrLen then
    Wait2Len := MaxStrLen
  else
    Wait2Len := Len;

  if Wait2Len<Wait2SubLen then
    Wait2Len := Wait2SubLen;

  if Pos<1 then
    Wait2SubPos := 1
  else if Pos>Wait2Len-Wait2SubLen+1 then
    Wait2SubPos := Wait2Len-Wait2SubLen+1
  else
    Wait2SubPos := Pos;

  Wait2Count := 0;
  Wait2Str[0] := #0;
  Wait2Found := Wait2SubStr[0]=#0;
end;

function Wait: integer;
var
  b: byte;
  Found: integer;
  Str: PChar;
begin
  Found := 0;
  while (Found=0) and Read1Byte(b) do
    for i := 10 downto 1 do
    begin
      Str := PWaitStr[i];
      if Str<>nil then
      begin
        if Str[WaitCount[i]]=char(b) then
        begin
          inc(WaitCount[i]);
        end
        else
          WaitCount[i] := 0;
        if WaitCount[i]=WaitStrLen[i] then
          Found := i;
      end;
    end;
  Wait := Found;
  if Found>0 then ClearWait;
end;

function Wait2: BOOL;
var
  b: byte;
begin
  while not (Wait2Found and (Wait2Count=Wait2Len))
        and Read1Byte(b) do
  begin
    if Wait2Count>=Wait2Len then
    begin
      Move(Wait2Str[1],Wait2Str[0],Wait2Len-1);
      Wait2Str[Wait2Len-1] := char(b);
      Wait2Count := Wait2Len;
    end
    else begin
      Wait2Str[Wait2Count] := char(b);
      inc(Wait2Count);
    end;
    Wait2Str[Wait2Count] := #0;
    if not Wait2Found and
      (Wait2Count>=Wait2SubPos+Wait2SubLen-1) then
      Wait2Found :=
        strlcomp(@Wait2Str[Wait2SubPos-1],Wait2SubStr,Wait2SubLen)=0;
  end;
  Wait2 :=  Wait2Found and (Wait2Count=Wait2Len);
end;

procedure SetFile(FN: PChar);
var
  Cmd: array[0..81] of char;
begin
  Cmd[0] := CmdSetFile;
  StrCopy(@Cmd[1],FN);
  DdeClientTransaction(@Cmd[0],StrLen(Cmd)+1,ConvH,0,CF_OEMTEXT,XTYP_EXECUTE,1000,nil);
end;

procedure SetBinary(BinFlag: word);
var
  Cmd: array[0..2] of char;
begin
  Cmd[0] := CmdSetBinary;
  Cmd[1] := char($30 + BinFlag and 1);
  Cmd[2] := #0;
  DdeClientTransaction(@Cmd[0],StrLen(Cmd)+1,ConvH,0,CF_OEMTEXT,XTYP_EXECUTE,1000,nil);
end;

procedure SetAppend(AppendFlag: word);
var
  Cmd: array[0..2] of char;
begin
  Cmd[0] := CmdSetAppend;
  Cmd[1] := char($30 + AppendFlag and 1);
  Cmd[2] := #0;
  DdeClientTransaction(@Cmd[0],StrLen(Cmd)+1,ConvH,0,CF_OEMTEXT,XTYP_EXECUTE,1000,nil);
end;

procedure SetXOption(XOption: word);
var
  Cmd: array[0..2] of char;
begin
  if (XOption<1) or (XOption>3) then XOption := 1;
  Cmd[0] := CmdSetXModemOpt;
  Cmd[1] := char($30 + XOption);
  Cmd[2] := #0;
  DdeClientTransaction(@Cmd[0],StrLen(Cmd)+1,ConvH,0,CF_OEMTEXT,XTYP_EXECUTE,1000,nil);
end;

function SendCmnd(OpId: char; Wait: boolean): word;
var
  Cmd: array[0..1] of char;
begin
  if ConvH=0 then
  begin
    SendCmnd := ErrLinkFirst;
    exit;
  end
  else
    SendCmnd := 0;

  if Wait then TTLStatus := IdTTLWaitCmndEnd;
  Cmd[0] := OpId;
  Cmd[1] := #0;
  if DdeClientTransaction(@Cmd[0],StrLen(Cmd)+1,ConvH,0,CF_OEMTEXT,XTYP_EXECUTE,1000,nil)=0
  then
    TTLStatus := IdTTLRun;
end;

begin
  Inst := 0;
  ConvH := 0;
  Service := 0;
  Topic := 0;
  Item := 0;
  DdeCallBackPtr := nil;
  ComReady := 0;
  OutLen := 0;
  RBufStart := 0;
  RBufPtr := 0;
  RBufCount := 0;
  FFFlag := false;
  for i := 1 to 10 do
  begin
    PWaitStr[i] := nil;
    WaitStrLen[i] := 0;
    WaitCount[i] := 0;
  end;
end.