{Tera Term
 Copyright(C) 1994-1996 T. Teranishi
 All rights reserved.}

{TTMACRO.EXE, dialog boxes}
unit TTMDLG;

interface
{$I teraterm.inc}

{$IFDEF Delphi}
uses Messages, WinTypes, WinProcs, OWindows, ODialogs, Strings, WinDos,
     Commdlg, TTLib;
{$ELSE}
uses WinTypes, WinProcs, WObjects, Strings, WinDos, Commdlg, TTLib;
{$ENDIF}

const
  MaxStrLen = 256;

type
  PErrDlg = ^TErrDlg;
  TErrDlg = object(TDialog)
    ErrStr,LineStr: PChar;
    constructor Init(Err, Line: PChar);
    procedure SetupWindow; virtual;
  end;

type
  PInpDlg = ^TInpDlg;
  TInpDlg = object(TDialog)
    InputStr, TextStr, TitleStr: PChar;
    constructor Init(Input, Text, Title: PChar; Paswd: BOOL);
    procedure SetupWindow; virtual;
    procedure OK(var Msg: TMessage);
      virtual id_first + id_OK;
  end;

var
  FileName: array[0..fsPathName] of char;
  TopicName: array[0..10] of char;
  ShortName: array[0..fsFileName+fsExtension] of char;
  Param2: array[0..fsPathName] of char;
  Param3: array[0..fsPathName] of char; 

function GetFileName: boolean;

implementation

const
  IdErrDlg = 200;
  IdErrMsg = 201;
  IdErrLine = 202;

  IdInpDlg = 300;
  IdInpText = 301;
  IdInpEdit = 302;

  IdPaswdDlg = 400;

constructor TErrDlg.Init(Err, Line: PChar);
begin
  TDialog.Init(Application^.MainWindow,PChar(IdErrDlg));
  ErrStr := Err;
  LineStr := Line;
end;

procedure TErrDlg.SetupWindow;
begin
  TDialog.SetupWindow;
  SetDlgItemText(HWindow, IdErrMsg, ErrStr);
  SetDlgItemText(HWindow, IdErrLine, LineStr);
end;

constructor TInpDlg.Init(Input, Text, Title: PChar; Paswd: BOOL);
begin
  if Paswd then
    TDialog.Init(Application^.MainWindow,PChar(IdPaswdDlg))
  else
    TDialog.Init(Application^.MainWindow,PChar(IdInpDlg));
  InputStr := Input;
  TextStr := Text;
  TitleStr := Title;
end;

procedure TInpDlg.SetupWindow;
begin
  TDialog.SetupWindow;
  SetWindowText(HWindow, TitleStr); 
  SetDlgItemText(HWindow, IdInpText, TextStr);
  SendDlgItemMessage(HWindow, IdInpEdit, em_LimitText,MaxStrLen, 0);
end;

procedure TInpDlg.OK(var Msg: TMessage);
begin
  GetDlgItemText(HWindow, IdInpEdit, InputStr, MaxStrLen);
  TDialog.OK(Msg);
end;

function GetFileName: boolean;
var
  i, j, k: integer;
  HomeDir: array[0..fsPathName] of char;
  SearchRec: TSearchRec;
  FNFilter: array [0..30] of Char;
  FNameRec: TOpenFileName;
  Temp: array[0..fsPathName] of char;
begin
  {Get home directory}
  GetModuleFileName(HInstance,FileName,SizeOf(FileName));
  ExtractDirNameJ(FileName,HomeDir);
  SetCurDir(HomeDir);

  {Get command line parameters}
  FileName[0] := #0;
  TopicName[0] := #0;
  for i := 1 to ParamCount do
  begin
    StrPCopy(Temp,ParamStr(i));
    if strlicomp(Temp,'/D=',3)=0 then
      strcopy(TopicName,@Temp[3])
    else if (FileName[0]=#0) then
      strcopy(FileName,Temp);
  end;

  if strlen(FileName)>0 then
  begin
    if GetFileNamePosJ(FileName,j,k) then
    begin
      FitFileName(@FileName[k],'.TTL');
      StrUpperJ(FileName);
      StrCopy(ShortName,@FileName[k]);
    end
    else
      FileName[0] := #0;
  end;

  if FileName[0]=#0 then
  begin
    FillChar(FNFilter, SizeOf(FNFilter), #0);
    FillChar(FNameRec, SizeOf(TOpenFileName), #0);
    StrCopy(FNFilter, 'Macro files (*.ttl)');
    StrCopy(@FNFilter[StrLen(FNFilter)+1], '*.ttl');      

    with FNameRec do
    begin
      lStructSize   := sizeof(TOpenFileName);
      hwndOwner     := Application^.MainWindow^.HWindow;
      lpstrFilter   := FNFilter;
      nFilterIndex := 1;
      lpstrFile := FileName;
      nMaxFile := SizeOf(FileName);
      lpstrInitialDir := HomeDir;
      flags := ofn_FileMustExist or ofn_HideReadOnly;
      lpstrDefExt := 'TTL';
      lpstrTitle := 'TTMACRO: Open macro';
    end;

    if GetOpenFileName(FNameRec) then
      StrCopy(ShortName,@FileName[FNameRec.nFileOffset])
    else
      FileName[0] := #0;

  end;

  if FileName[0]=#0 then
  begin
    ShortName[0] := #0;
    GetFileName := false;
  end
  else
    GetFileName := true;

end;


end.